"""
Testing for AGE-ABM Backend (backend, visual and utils)
@Author Max Hall
@Co-Authors Meghan Ireland and Matthew Fleischman

"""

import visuals.visual_classes as vis_classes

class TestVisualiseAgentClass:
    ''' Tests for Import Details methods '''
    def test__init__(self):
        ''' Tests that the initialisation of the object '''
        object1 = vis_classes.VisualiseAgent("visual_agent_name", ["Agent1", "Agent2", "Agent3"], "plot_data_type", "plot_type", "comp_of_interest", "attr_of_interest")
        assert str(type(object1)) == "<class 'visuals.visual_classes.VisualiseAgent'>"

        assert object1.visual_agent_name == "visual_agent_name"
        assert set(object1.compare_agent_list) == set(["Agent1", "Agent2", "Agent3"])
        assert object1.plot_data_type == "plot_data_type"
        assert object1.plot_type == "plot_type"
        assert object1.comp_of_interest == "comp_of_interest"
        assert object1.attr_of_interest == "attr_of_interest"


    def test_get_visual_agent_name(self):
        ''' Tests getting the visual_agent_name of the object '''
        object1 = vis_classes.VisualiseAgent("visual_agent_name", ["Agent1", "Agent2", "Agent3"], "plot_data_type", "plot_type", "comp_of_interest", "attr_of_interest")

        object1.get_visual_agent_name()
        assert object1.visual_agent_name == "visual_agent_name"


    def test_get_compare_agent_list(self):
        ''' Tests getting the compare_agent_list of the object '''
        object1 = vis_classes.VisualiseAgent("visual_agent_name", ["Agent1", "Agent2", "Agent3"], "plot_data_type", "plot_type", "comp_of_interest", "attr_of_interest")

        object1.get_compare_agent_list()
        assert set(object1.compare_agent_list) == set(["Agent1", "Agent2", "Agent3"])


    def test_get_plot_data_type(self):
        ''' Tests getting the plot_data_type of the object '''
        object1 = vis_classes.VisualiseAgent("visual_agent_name", ["Agent1", "Agent2", "Agent3"], "plot_data_type", "plot_type", "comp_of_interest", "attr_of_interest")

        object1.get_plot_data_type()
        assert object1.plot_data_type == "plot_data_type"


    def test_get_plot_type(self):
        ''' Tests getting the plot_type of the object '''
        object1 = vis_classes.VisualiseAgent("visual_agent_name", ["Agent1", "Agent2", "Agent3"], "plot_data_type", "plot_type", "comp_of_interest", "attr_of_interest")

        object1.get_plot_type()
        assert object1.plot_type == "plot_type"


    def test_get_comp_of_interest(self):
        ''' Tests getting the comp_of_interest of the object '''
        object1 = vis_classes.VisualiseAgent("visual_agent_name", ["Agent1", "Agent2", "Agent3"], "plot_data_type", "plot_type", "comp_of_interest", "attr_of_interest")

        object1.get_comp_of_interest()
        assert object1.comp_of_interest == "comp_of_interest"


    def test_get_attr_of_interest(self):
        ''' Tests getting the attr_of_interest of the object '''
        object1 = vis_classes.VisualiseAgent("visual_agent_name", ["Agent1", "Agent2", "Agent3"], "plot_data_type", "plot_type", "comp_of_interest", "attr_of_interest")

        object1.get_attr_of_interest()
        assert object1.attr_of_interest == "attr_of_interest"

    